## net.sf.saxon.tree.tiny
Class TinyElementImpl

    java.lang.Object
      net.sf.saxon.tree.tiny.TinyNodeImpl
          net.sf.saxon.tree.tiny.TinyParentNodeImpl
              net.sf.saxon.tree.tiny.TinyElementImpl

All Implemented Interfaces:
  Source, SourceLocator, PullEvent, FingerprintedNode, Item, NodeInfo, ValueRepresentation

    public final class TinyElementImpl

extends TinyParentNodeImpl

A node in the XML parse tree representing an XML element.

This class is an implementation of NodeInfo. The object is a wrapper around one entry in the arrays maintained by the TinyTree. Note that the same node might be represented by different TinyElementImpl objects at different times.

Author:
  Michael H. Kay

Field Summary

Fields inherited from class net.sf.saxon.tree.tiny.TinyNodeImpl
`NODE_LETTER, nodeNr, parent, tree`

Fields inherited from interface net.sf.saxon.om.NodeInfo
`ALL_NAMESPACES, EMPTY_NAMESPACE_LIST, IS_DTD_TYPE, IS_NILLED, LOCAL_NAMESPACES, NO_NAMESPACES`

Fields inherited from interface net.sf.saxon.om.ValueRepresentation
`EMPTY_VALUE_ARRAY`

Constructor Summary
`TinyElementImpl(TinyTree tree, int nodeNr)` Constructor - create a tiny element node

Method Summary
`Value` `atomize()` Get the typed value.
`void` `copy(Receiver receiver, int copyOptions, int locationId)` Copy this node to a given receiver
`String` `getAttributeValue(int fingerprint)` Get the value of a given attribute of this node
`String` `getBaseURI()` Get the base URI of this element node.
`int[]` `getDeclaredNamespaces(int[] buffer)` Get all namespace undeclarations and undeclarations defined on this element.
`static int[]` `getDeclaredNamespaces(TinyTree tree, int nodeNr, int[] buffer)` Static method to get all namespace undeclarations and undeclarations defined on a given element, without instantiating the node object.
`static int[]` `getInScopeNamespaces(TinyTree tree, int nodeNr, int[] buffer)` Get all the inscope namespaces for an element node.
`int` `getNodeKind()` Return the type of node.
`int` `getTypeAnnotation()` Get the type annotation of this node, if any Returns Type.UNTYPED_ANY if there is no type annotation
`SequenceIterator` `getTypedValue()` Get the typed value of this node.
`String` `getURIForPrefix(String prefix, boolean useDefault)` Get the namespace URI corresponding to a given prefix.
`boolean` `isId()` Determine whether this node has the is-id property
`boolean` `isIdref()` Determine whether this node has the is-idref property

Methods inherited from class net.sf.saxon.tree.tiny.TinyParentNodeImpl
`getStringValue, getStringValueCS, getStringValueCS, hasChildNodes`

Methods inherited from class net.sf.saxon.tree.tiny.TinyNodeImpl

`compareOrder, equals, generateId, getColumnNumber, getConfiguration, getDisplayName, getDocumentNumber, getDocumentRoot, getFingerprint, getLineNumber, getLocalPart, getNameCode, getNamePool, getNodeNumber, getParent, getPrefix, getPublicId, getRoot, getSequenceNumber, getSystemId, getTree, getURI, hashCode, isAncestorOrSelf, isNilled, isSameNodeInfo, iterateAxis, iterateAxis, setParentNode, setSystemId`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### TinyElementImpl

    public TinyElementImpl(TinyTree tree,
                           int nodeNr)

  Constructor - create a tiny element node

  Parameters:
    `tree` - the Tinytree containing the node
    `nodeNr` - the node number

Method Detail

### getNodeKind

    public final int getNodeKind()

  Return the type of node.

  Returns:
    Type.ELEMENT
  See Also:
    `Type`

### getBaseURI

    public String getBaseURI()

  Get the base URI of this element node. This will be the same as the System ID unless xml:base has been used.

  Specified by:
    `getBaseURI` in interface `NodeInfo`
  Overrides:
    `getBaseURI` in class `TinyNodeImpl`
  Returns:
    the base URI of the node. This may be null if the base URI is unknown, including the case where the node has no parent.

### getTypeAnnotation

    public int getTypeAnnotation()

  Get the type annotation of this node, if any Returns Type.UNTYPED_ANY if there is no type annotation

  Specified by:
    `getTypeAnnotation` in interface `NodeInfo`
  Overrides:
    `getTypeAnnotation` in class `TinyNodeImpl`
  Returns:
    the type annotation of the node, under the mask NamePool.FP_MASK, and optionally the bit setting IS_DTD_TYPE in the case of a DTD-derived ID or IDREF/S type (which is treated as untypedAtomic for the purposes of obtaining the typed value).

    For elements and attributes, this is the type annotation as defined in XDM. For document nodes, it should be one of XS_UNTYPED if the document has not been validated, or XS_ANY_TYPE if validation has taken place (that is, if any node in the document has an annotation other than Untyped or UntypedAtomic).

### getTypedValue

    public SequenceIterator getTypedValue()
                                   throws XPathException

  Get the typed value of this node. If there is no type annotation, we return the string value, as an instance of xs:untypedAtomic

  Returns:
    an iterator over the items in the typed value of the node or atomic value. The items returned by this iterator will always be atomic values.
  Throws:
    `XPathException` - where no typed value is available, for example in the case of an element with complex content

### atomize

    public Value atomize()
                  throws XPathException

  Get the typed value. The result of this method will always be consistent with the method `Item.getTypedValue()`. However, this method is often more convenient and may be more efficient, especially in the common case where the value is expected to be a singleton.

  Returns:
    the typed value. It will be a Value representing a sequence whose items are atomic values.
  Throws:
    `XPathException`
  Since:
    8.5

### getDeclaredNamespaces

    public int[] getDeclaredNamespaces(int[] buffer)

  Get all namespace undeclarations and undeclarations defined on this element.

  Specified by:
    `getDeclaredNamespaces` in interface `NodeInfo`
  Overrides:
    `getDeclaredNamespaces` in class `TinyNodeImpl`
  Parameters:
    `buffer` - If this is non-null, and the result array fits in this buffer, then the result may overwrite the contents of this array, to avoid the cost of allocating a new array on the heap.
  Returns:
    An array of integers representing the namespace declarations and undeclarations present on this element. For a node other than an element, return null. Otherwise, the returned array is a sequence of namespace codes, whose meaning may be interpreted by reference to the name pool. The top half word of each namespace code represents the prefix, the bottom half represents the URI. If the bottom half is zero, then this is a namespace undeclaration rather than a declaration. The XML namespace is never included in the list. If the supplied array is larger than required, then the first unused entry will be set to -1.

    For a node other than an element, the method returns null.

### getDeclaredNamespaces

    public static int[] getDeclaredNamespaces(TinyTree tree,
                                              int nodeNr,
                                              int[] buffer)

  Static method to get all namespace undeclarations and undeclarations defined on a given element, without instantiating the node object.

  Parameters:
    `tree` - The tree containing the given element node
    `nodeNr` - The node number of the given element node within the tinyTree
    `buffer` - If this is non-null, and the result array fits in this buffer, then the result may overwrite the contents of this array, to avoid the cost of allocating a new array on the heap.
  Returns:
    An array of integers representing the namespace declarations and undeclarations present on this element. For a node other than an element, return null. Otherwise, the returned array is a sequence of namespace codes, whose meaning may be interpreted by reference to the name pool. The top half word of each namespace code represents the prefix, the bottom half represents the URI. If the bottom half is zero, then this is a namespace undeclaration rather than a declaration. The XML namespace is never included in the list. If the supplied array is larger than required, then the first unused entry will be set to -1.

    For a node other than an element, the method returns null.

### getInScopeNamespaces

    public static int[] getInScopeNamespaces(TinyTree tree,
                                             int nodeNr,
                                             int[] buffer)

  Get all the inscope namespaces for an element node. This method is better than the generic method provided by `NamespaceIterator` because it doesn't require the element node (or its ancestors) to be instantiated as objects.

  Parameters:
    `tree` - the TinyTree containing the element node whose in-scope namespaces are required
    `nodeNr` - the node number of the element node within the TinyTree. The caller is responsible for ensuring that this is indeed an element node
    `buffer` - a buffer to hold the result, assuming it is large enough
  Returns:
    an integer array of namespace codes representing the inscope namespaces of the given element. The returned array will either be fully used, or it will contain a -1 entry marking the effective end of the list of namespace codes. Note that only distinct declared namespaces are included in the result; it does not contain any entries for namespace undeclarations or for overridden declarations.

### getAttributeValue

    public String getAttributeValue(int fingerprint)

  Get the value of a given attribute of this node

  Specified by:
    `getAttributeValue` in interface `NodeInfo`
  Overrides:
    `getAttributeValue` in class `TinyNodeImpl`
  Parameters:
    `fingerprint` - The fingerprint of the attribute name
  Returns:
    the attribute value if it exists or null if not

### copy

    public void copy(Receiver receiver,
                     int copyOptions,
                     int locationId)
              throws XPathException

  Copy this node to a given receiver

  Parameters:
    `copyOptions` -
    `receiver` - the Receiver to which the node should be copied. It is the caller's responsibility to ensure that this Receiver is open before the method is called (or that it is self-opening), and that it is closed after use.
    `locationId` - If non-zero, identifies the location of the instruction that requested this copy. If zero, indicates that the location information
  Throws:
    `XPathException`

### getURIForPrefix

    public String getURIForPrefix(String prefix,
                                  boolean useDefault)

  Get the namespace URI corresponding to a given prefix. Return null if the prefix is not in scope.

  Parameters:
    `prefix` - the namespace prefix. May be the zero-length string, indicating that there is no prefix. This indicates either the default namespace or the null namespace, depending on the value of useDefault.
    `useDefault` - true if the default namespace is to be used when the prefix is "". If false, the method returns "" when the prefix is "".
  Returns:
    the uri for the namespace, or null if the prefix is not in scope. The "null namespace" is represented by the pseudo-URI "".

### isId

    public boolean isId()

  Determine whether this node has the is-id property

  Specified by:
    `isId` in interface `NodeInfo`
  Overrides:
    `isId` in class `TinyNodeImpl`
  Returns:
    true if the node is an ID

### isIdref

    public boolean isIdref()

  Determine whether this node has the is-idref property

  Specified by:
    `isIdref` in interface `NodeInfo`
  Overrides:
    `isIdref` in class `TinyNodeImpl`
  Returns:
    true if the node is an IDREF or IDREFS element or attribute

Copyright (c) 2004-2010 Saxonica Limited. All rights reserved.